#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

package require tls

# Handle socket events during handshake.

proc handshakeHandler {channel clientaddr} {
    global tlssignal

    puts "handshakeHandler: $channel $clientaddr"

    if {[eof $channel]} {
      close $channel
    }

    set fail [catch {tls::handshake $channel} complete]

    if {!$fail && $complete} {
	set tlssignal($channel) ""
    }
}

proc getPassword {} {
    return "testing"
}


proc openConnection {channel clientaddr clientport } {
    global tlssignal
    
    # Wait until the handshake is complete
    fileevent $channel readable [list handshakeHandler $channel $clientaddr]
    vwait tlssignal($channel)
    
    fileevent $channel readable [list processMessage $channel]
}
 
proc handshakeHandler {channel clientaddr} {
    global tlssignal
    
    if {[eof $channel]} {
      close $channel
      return
    }
     
    set fail [catch {tls::handshake $channel} complete]
    
    if {!$fail && $complete} {
        set tlssignal($channel) ""
    }
}

proc processMessage {channel} {
    if {[eof $channel]} {
      close $channel
      return
    }
    set rply [safeInterp eval [gets $channel]]
    puts $channel "$rply"
    flush $channel
}

# Create a safe interpreter
interp create -safe safeInterp

# Link the 'writeLog' procedure in this environment
# to the 'log' procedure in the safe child interpreter.

safeInterp alias log writeLog

# Define writeLog

proc writeLog {data} {
  set of [open /tmp/agent.log "a"]
  puts $of $data
  close $of
}

# Define a procedure to use the logging facility
safeInterp eval {
  proc checksum {string} {
    set total 0
    foreach c [split $string ""] {
      scan $c %c x
      incr total $x
    }
  log "$total $string"
  return $total
  }
}
set port			5000
set certDir			SimpleCA28/certificates

set s [tls::socket -server openConnection \
    -cafile $certDir/../rootca.pem \
    -certfile $certDir/../1001.pem \
    -keyfile $certDir/www.noucorp.com.key \
    -request 1 -require 1 -password getPassword \
    $port]


vwait forever

